## xnnpack 0.0~git20200425.54f5917

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# Copyright 2019 Google LLC
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)

# ---[ Project and semantic versioning.
PROJECT(XNNPACK C CXX ASM)

# ---[ Options.
SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
SET_PROPERTY(CACHE XNNPACK_LIBRARY_TYPE PROPERTY STRINGS default static shared)
OPTION(XNNPACK_ENABLE_ASSEMBLY "Build XNNPACK with assembly micro-kernels" ON)
OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
OPTION(XNNPACK_BUILD_BENCHMARKS "Build XNNPACK benchmarks" ON)

# ---[ CMake options
INCLUDE(GNUInstallDirs)

IF(XNNPACK_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

IF(XNNPACK_ENABLE_ASSEMBLY)
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=1)
ELSE()
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=0)
ENDIF()

IF(MSVC)
  # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
  ADD_COMPILE_OPTIONS("/wd4146")
ENDIF()

# ---[ Build flags
IF(NOT CMAKE_SYSTEM_PROCESSOR)
  IF(IOS)
    LIST(LENGTH IOS_ARCH IOS_ARCH_COUNT)
    IF(IOS_ARCH_COUNT GREATER 1)
      MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple iOS architectures (${IOS_ARCH}). "
        "Specify a single architecture in IOS_ARCH and re-configure. ")
    ENDIF()
    IF(NOT IOS_ARCH MATCHES "^(i386|x86_64|AMD64|armv7.*|arm64.*)$")
      MESSAGE(FATAL_ERROR "Unrecognized IOS_ARCH = ${IOS_ARCH}")
    ENDIF()
  ELSE()
    MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR is not defined")
  ENDIF()
ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|x86|x86_64|AMD64|armv[5-8].*|aarch64)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_PROCESSOR = ${CMAKE_SYSTEM_PROCESSOR}")
ENDIF()

IF(NOT CMAKE_SYSTEM_NAME)
  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")
ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Darwin|Linux|Android|Windows)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")
ENDIF()

# ---[ Download deps
IF(NOT DEFINED CLOG_SOURCE_DIR)
  MESSAGE(STATUS "Downloading clog to ${CMAKE_BINARY_DIR}/clog-source (define CLOG_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadCLog.cmake "${CMAKE_BINARY_DIR}/clog-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
  SET(CLOG_SOURCE_DIR "${CMAKE_BINARY_DIR}/clog-source" CACHE STRING "clog source directory")
ENDIF()

IF(NOT DEFINED CPUINFO_SOURCE_DIR)
  MESSAGE(STATUS "Downloading cpuinfo to ${CMAKE_BINARY_DIR}/cpuinfo-source (define CPUINFO_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadCpuinfo.cmake "${CMAKE_BINARY_DIR}/cpuinfo-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
  SET(CPUINFO_SOURCE_DIR "${CMAKE_BINARY_DIR}/cpuinfo-source" CACHE STRING "cpuinfo source directory")
ENDIF()

IF(NOT DEFINED FP16_SOURCE_DIR)
  MESSAGE(STATUS "Downloading FP16 to ${CMAKE_BINARY_DIR}/FP16-source (define FP16_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadFP16.cmake "${CMAKE_BINARY_DIR}/FP16-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
  SET(FP16_SOURCE_DIR "${CMAKE_BINARY_DIR}/FP16-source" CACHE STRING "FP16 source directory")
ENDIF()

IF(NOT DEFINED FXDIV_SOURCE_DIR)
  MESSAGE(STATUS "Downloading FXdiv to ${CMAKE_BINARY_DIR}/FXdiv-source (define FXDIV_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadFXdiv.cmake "${CMAKE_BINARY_DIR}/FXdiv-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  SET(FXDIV_SOURCE_DIR "${CMAKE_BINARY_DIR}/FXdiv-source" CACHE STRING "FXdiv source directory")
ENDIF()

IF(NOT DEFINED PSIMD_SOURCE_DIR)
  MESSAGE(STATUS "Downloading PSimd to ${CMAKE_BINARY_DIR}/psimd-source (define PSIMD_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadPSimd.cmake "${CMAKE_BINARY_DIR}/psimd-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
  SET(PSIMD_SOURCE_DIR "${CMAKE_BINARY_DIR}/psimd-source" CACHE STRING "PSimd source directory")
ENDIF()

IF(NOT DEFINED PTHREADPOOL_SOURCE_DIR)
  MESSAGE(STATUS "Downloading pthreadpool to ${CMAKE_BINARY_DIR}/pthreadpool-source (define PTHREADPOOL_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadPThreadPool.cmake "${CMAKE_BINARY_DIR}/pthreadpool-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
  SET(PTHREADPOOL_SOURCE_DIR "${CMAKE_BINARY_DIR}/pthreadpool-source" CACHE STRING "pthreadpool source directory")
ENDIF()

IF(XNNPACK_BUILD_TESTS AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Test to ${CMAKE_BINARY_DIR}/googletest-source (define GOOGLETEST_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  SET(GOOGLETEST_SOURCE_DIR "${CMAKE_BINARY_DIR}/googletest-source" CACHE STRING "Google Test source directory")
ENDIF()

IF(XNNPACK_BUILD_BENCHMARKS AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Benchmark to ${CMAKE_BINARY_DIR}/googlebenchmark-source (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CMAKE_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  SET(GOOGLEBENCHMARK_SOURCE_DIR "${CMAKE_BINARY_DIR}/googlebenchmark-source" CACHE STRING "Google Benchmark source directory")
ENDIF()

# ---[ XNNPACK library
SET(XNNPACK_OPERATOR_SRCS
  src/add-nc.c
  src/argmax-pooling-nhwc.c
  src/average-pooling-nhwc.c
  src/binary-elementwise-nd.c
  src/channel-pad-nc.c
  src/channel-shuffle-nc.c
  src/clamp-nc.c
  src/convolution-nchw.c
  src/convolution-nhwc.c
  src/deconvolution-nhwc.c
  src/fully-connected-nc.c
  src/global-average-pooling-ncw.c
  src/global-average-pooling-nwc.c
  src/hardswish-nc.c
  src/leaky-relu-nc.c
  src/max-pooling-nhwc.c
  src/prelu-nc.c
  src/resize-bilinear-nhwc.c
  src/sigmoid-nc.c
  src/softmax-nc.c
  src/unpooling-nhwc.c)

SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS})
LIST(APPEND XNNPACK_COLD_SRCS
  src/init.c
  src/memory.c
  src/operator-delete.c
  src/runtime.c
  src/subgraph.c
  src/tensor.c)

SET(XNNPACK_HOT_SRCS
  src/indirection.c
  src/operator-run.c)

SET(XNNPACK_TABLE_SRCS
  src/tables/exp2-k-over-64.c
  src/tables/exp2-k-over-2048.c)

SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
  src/f32-argmaxpool/4x-scalar-c1.c
  src/f32-argmaxpool/9p8x-scalar-c1.c
  src/f32-argmaxpool/9x-scalar-c1.c
  src/f32-avgpool/9p8x-minmax-scalar-c1.c
  src/f32-avgpool/9x-minmax-scalar-c1.c
  src/f32-clamp/gen/scalar-x1.c
  src/f32-clamp/gen/scalar-x2.c
  src/f32-clamp/gen/scalar-x4.c
  src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
  src/f32-conv-hwc2spchw/3x3s2p1c3x4-scalar-1x1.c
  src/f32-dwconv-spchw/3x3p1-scalar.c
  src/f32-dwconv-spchw/3x3s2p1-scalar.c
  src/f32-dwconv-spchw/5x5p2-scalar.c
  src/f32-dwconv-spchw/5x5s2p2-scalar.c
  src/f32-dwconv/gen/up1x4-scalar.c
  src/f32-dwconv/gen/up1x4-scalar-acc2.c
  src/f32-dwconv/gen/up1x9-scalar.c
  src/f32-dwconv/gen/up1x9-scalar-acc2.c
  src/f32-dwconv/gen/up1x25-scalar.c
  src/f32-dwconv/gen/up1x25-scalar-acc2.c
  src/f32-dwconv/gen/up2x4-scalar.c
  src/f32-dwconv/gen/up2x4-scalar-acc2.c
  src/f32-dwconv/gen/up2x9-scalar.c
  src/f32-dwconv/gen/up2x9-scalar-acc2.c
  src/f32-dwconv/gen/up2x25-scalar.c
  src/f32-dwconv/gen/up2x25-scalar-acc2.c
  src/f32-dwconv/gen/up1x4-minmax-scalar.c
  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up1x9-minmax-scalar.c
  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up1x25-minmax-scalar.c
  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x4-minmax-scalar.c
  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x9-minmax-scalar.c
  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x25-minmax-scalar.c
  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
  src/f32-gavgpool-spchw/scalar-x1.c
  src/f32-gavgpool/7p7x-minmax-scalar-c1.c
  src/f32-gavgpool/7x-minmax-scalar-c1.c
  src/f32-gemm/gen/1x4-scalar.c
  src/f32-gemm/gen/2x4-scalar.c
  src/f32-gemm/gen/4x2-scalar.c
  src/f32-gemm/gen/4x4-scalar.c
  src/f32-gemm/gen/1x4-minmax-scalar.c
  src/f32-gemm/gen/2x4-minmax-scalar.c
  src/f32-gemm/gen/4x2-minmax-scalar.c
  src/f32-gemm/gen/4x4-minmax-scalar.c
  src/f32-gemm/gen-inc/1x4inc-minmax-scalar.c
  src/f32-gemm/gen-inc/2x4inc-minmax-scalar.c
  src/f32-gemm/gen-inc/4x4inc-minmax-scalar.c
  src/f32-hswish/gen/scalar-x1.c
  src/f32-hswish/gen/scalar-x2.c
  src/f32-hswish/gen/scalar-x4.c
  src/f32-ibilinear/gen/scalar-c1.c
  src/f32-ibilinear/gen/scalar-c2.c
  src/f32-ibilinear/gen/scalar-c4.c
  src/f32-igemm/gen/1x4-scalar.c
  src/f32-igemm/gen/2x4-scalar.c
  src/f32-igemm/gen/4x2-scalar.c
  src/f32-igemm/gen/4x4-scalar.c
  src/f32-igemm/gen/1x4-minmax-scalar.c
  src/f32-igemm/gen/2x4-minmax-scalar.c
  src/f32-igemm/gen/4x2-minmax-scalar.c
  src/f32-igemm/gen/4x4-minmax-scalar.c
  src/f32-maxpool/9p8x-minmax-scalar-c1.c
  src/f32-pavgpool/9p8x-minmax-scalar-c1.c
  src/f32-pavgpool/9x-minmax-scalar-c1.c
  src/f32-ppmm/gen/2x4-minmax-scalar.c
  src/f32-ppmm/gen/3x3-minmax-scalar.c
  src/f32-ppmm/gen/4x2-minmax-scalar.c
  src/f32-ppmm/gen/4x4-minmax-scalar.c
  src/f32-prelu/gen/scalar-2x1.c
  src/f32-prelu/gen/scalar-2x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x1.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x2-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4-acc4.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x1.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x2-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4-acc4.c
  src/f32-rmax/scalar.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x1.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x2.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x4.c
  src/f32-sigmoid/gen/scalar-lut64-p2-div-x1.c

=== debian/changelog ===
xnnpack (0.0~git20200425.54f5917-2) unstable; urgency=medium

  * Fixup the clog patch (it was empty in the previous upload due to mistake)
  * Apply wrap-and-srot.
  * Create symbols control file for libXNNPACK.so
  * List not-installed files.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 09:27:23 +0800

xnnpack (0.0~git20200425.54f5917-1) experimental; urgency=medium

  * Initial release. (Closes: #958818)

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Apr 2020 15:04:57 +0800

=== debian/control ===
Source: xnnpack
Section: math
Homepage: https://github.com/google/XNNPACK
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/xnnpack.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/xnnpack
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               googletest,
               libcpuinfo-dev,
               libfp16-dev,
               libfxdiv-dev,
               libpsimd-dev,
               libpthreadpool-dev,
               ninja-build
Rules-Requires-Root: no

Package: libxnnpack-dev
Architecture: any
Depends: libxnnpack0 (= ${binary:Version}), ${misc:Depends}
Description: High-efficiency floating-point neural network inference operators (dev)
 XNNPACK is a highly optimized library of floating-point neural network
 inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
 intended for direct use by deep learning practitioners and researchers; instead
 it provides low-level performance primitives for accelerating high-level
 machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
 and MediaPipe.
 .
 This package contains the development files.

Package: libxnnpack0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: High-efficiency floating-point neural network inference operators (libs)
 XNNPACK is a highly optimized library of floating-point neural network
 inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
 intended for direct use by deep learning practitioners and researchers; instead
 it provides low-level performance primitives for accelerating high-level
 machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
 and MediaPipe.
 .
 This package contains the shared object.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening+=all
%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DXNNPACK_USE_SYSTEM_LIBS=ON \
		-DXNNPACK_BUILD_TESTS=OFF \
		-DXNNPACK_BUILD_BENCHMARKS=OFF \
		-DGOOGLETEST_SOURCE_DIR=/usr/src/googletest

override_dh_auto_test:
	-dh_auto_test

## xnnpack 0.0~git20200827.37297a6

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# Copyright 2019 Google LLC
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)

# ---[ Project and semantic versioning.
PROJECT(XNNPACK C CXX ASM)

# ---[ Options.
SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
SET_PROPERTY(CACHE XNNPACK_LIBRARY_TYPE PROPERTY STRINGS default static shared)
OPTION(XNNPACK_ENABLE_ASSEMBLY "Build XNNPACK with assembly micro-kernels" ON)
OPTION(XNNPACK_ENABLE_MEMOPT "Build XNNPACK with optimized memory allocation scheme" ON)
OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
OPTION(XNNPACK_BUILD_BENCHMARKS "Build XNNPACK benchmarks" ON)
OPTION(XNNPACK_USE_SYSTEM_LIBS "Use system-provided dependency libraries" OFF)

# ---[ CMake options
INCLUDE(GNUInstallDirs)

IF(XNNPACK_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

IF(XNNPACK_ENABLE_ASSEMBLY)
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=1)
ELSE()
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=0)
ENDIF()

IF(XNNPACK_ENABLE_MEMOPT)
  ADD_DEFINITIONS(-DXNN_ENABLE_MEMOPT=1)
ELSE()
  ADD_DEFINITIONS(-DXNN_ENABLE_MEMOPT=0)
ENDIF()

IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
  ADD_COMPILE_OPTIONS("/wd4146")
ENDIF()

IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  # Disable "note: parameter passing for argument of type ... changed/will change in ..."
  ADD_COMPILE_OPTIONS("-Wno-psabi")
ENDIF()

# ---[ Build flags
IF(NOT CMAKE_SYSTEM_PROCESSOR)
  IF(IOS)
    LIST(LENGTH IOS_ARCH IOS_ARCH_COUNT)
    IF(IOS_ARCH_COUNT GREATER 1)
      MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple iOS architectures (${IOS_ARCH}). "
        "Specify a single architecture in IOS_ARCH and re-configure. ")
    ENDIF()
    IF(NOT IOS_ARCH MATCHES "^(i386|x86_64|AMD64|armv7.*|arm64.*)$")
      MESSAGE(FATAL_ERROR "Unrecognized IOS_ARCH = ${IOS_ARCH}")
    ENDIF()
  ELSE()
    MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR is not defined")
  ENDIF()
ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|x86|x86_64|AMD64|armv[5-8].*|aarch64)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_PROCESSOR = ${CMAKE_SYSTEM_PROCESSOR}")
ENDIF()

IF(NOT CMAKE_SYSTEM_NAME)
  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")
ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Darwin|Linux|Android|Windows|CYGWIN|MSYS)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")
ENDIF()

# ---[ Download deps
IF(NOT XNNPACK_USE_SYSTEM_LIBS)
  IF(NOT DEFINED CLOG_SOURCE_DIR)
    MESSAGE(STATUS "Downloading clog to ${CMAKE_BINARY_DIR}/clog-source (define CLOG_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadCLog.cmake "${CMAKE_BINARY_DIR}/clog-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
    SET(CLOG_SOURCE_DIR "${CMAKE_BINARY_DIR}/clog-source" CACHE STRING "clog source directory")
  ENDIF()

  IF(NOT DEFINED CPUINFO_SOURCE_DIR)
    MESSAGE(STATUS "Downloading cpuinfo to ${CMAKE_BINARY_DIR}/cpuinfo-source (define CPUINFO_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadCpuinfo.cmake "${CMAKE_BINARY_DIR}/cpuinfo-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
    SET(CPUINFO_SOURCE_DIR "${CMAKE_BINARY_DIR}/cpuinfo-source" CACHE STRING "cpuinfo source directory")
  ENDIF()

  IF(NOT DEFINED FP16_SOURCE_DIR)
    MESSAGE(STATUS "Downloading FP16 to ${CMAKE_BINARY_DIR}/FP16-source (define FP16_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadFP16.cmake "${CMAKE_BINARY_DIR}/FP16-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
    SET(FP16_SOURCE_DIR "${CMAKE_BINARY_DIR}/FP16-source" CACHE STRING "FP16 source directory")
  ENDIF()

  IF(NOT DEFINED FXDIV_SOURCE_DIR)
    MESSAGE(STATUS "Downloading FXdiv to ${CMAKE_BINARY_DIR}/FXdiv-source (define FXDIV_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadFXdiv.cmake "${CMAKE_BINARY_DIR}/FXdiv-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
    SET(FXDIV_SOURCE_DIR "${CMAKE_BINARY_DIR}/FXdiv-source" CACHE STRING "FXdiv source directory")
  ENDIF()

  IF(NOT DEFINED PSIMD_SOURCE_DIR)
    MESSAGE(STATUS "Downloading PSimd to ${CMAKE_BINARY_DIR}/psimd-source (define PSIMD_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadPSimd.cmake "${CMAKE_BINARY_DIR}/psimd-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
    SET(PSIMD_SOURCE_DIR "${CMAKE_BINARY_DIR}/psimd-source" CACHE STRING "PSimd source directory")
  ENDIF()

  IF(NOT DEFINED PTHREADPOOL_SOURCE_DIR)
    MESSAGE(STATUS "Downloading pthreadpool to ${CMAKE_BINARY_DIR}/pthreadpool-source (define PTHREADPOOL_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadPThreadPool.cmake "${CMAKE_BINARY_DIR}/pthreadpool-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
    SET(PTHREADPOOL_SOURCE_DIR "${CMAKE_BINARY_DIR}/pthreadpool-source" CACHE STRING "pthreadpool source directory")
  ENDIF()

  IF(XNNPACK_BUILD_TESTS AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
    MESSAGE(STATUS "Downloading Google Test to ${CMAKE_BINARY_DIR}/googletest-source (define GOOGLETEST_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
    SET(GOOGLETEST_SOURCE_DIR "${CMAKE_BINARY_DIR}/googletest-source" CACHE STRING "Google Test source directory")
  ENDIF()

  IF(XNNPACK_BUILD_BENCHMARKS AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
    MESSAGE(STATUS "Downloading Google Benchmark to ${CMAKE_BINARY_DIR}/googlebenchmark-source (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CMAKE_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
    SET(GOOGLEBENCHMARK_SOURCE_DIR "${CMAKE_BINARY_DIR}/googlebenchmark-source" CACHE STRING "Google Benchmark source directory")
  ENDIF()
ENDIF()

# ---[ XNNPACK library
SET(XNNPACK_OPERATOR_SRCS
  src/operators/argmax-pooling-nhwc.c
  src/operators/average-pooling-nhwc.c
  src/operators/binary-elementwise-nd.c
  src/operators/channel-shuffle-nc.c
  src/operators/constant-pad-nd.c
  src/operators/convolution-nchw.c
  src/operators/convolution-nhwc.c
  src/operators/deconvolution-nhwc.c
  src/operators/fully-connected-nc.c
  src/operators/global-average-pooling-ncw.c
  src/operators/global-average-pooling-nwc.c
  src/operators/leaky-relu-nc.c
  src/operators/max-pooling-nhwc.c
  src/operators/prelu-nc.c
  src/operators/resize-bilinear-nhwc.c
  src/operators/sigmoid-nc.c
  src/operators/softmax-nc.c
  src/operators/unary-elementwise-nc.c
  src/operators/unpooling-nhwc.c)

SET(XNNPACK_SUBGRAPH_SRCS
  src/subgraph/abs.c
  src/subgraph/add2.c
  src/subgraph/argmax-pooling-2d.c
  src/subgraph/average-pooling-2d.c
  src/subgraph/bankers-rounding.c
  src/subgraph/ceiling.c
  src/subgraph/clamp.c
  src/subgraph/convolution-2d.c
  src/subgraph/deconvolution-2d.c
  src/subgraph/depthwise-convolution-2d.c
  src/subgraph/divide.c
  src/subgraph/fully-connected.c
  src/subgraph/floor.c
  src/subgraph/global-average-pooling-2d.c
  src/subgraph/hardswish.c
  src/subgraph/leaky-relu.c
  src/subgraph/max-pooling-2d.c
  src/subgraph/maximum2.c
  src/subgraph/minimum2.c
  src/subgraph/multiply2.c
  src/subgraph/negate.c
  src/subgraph/prelu.c
  src/subgraph/sigmoid.c
  src/subgraph/softmax.c
  src/subgraph/static-constant-pad.c
  src/subgraph/static-reshape.c
  src/subgraph/static-resize-bilinear-2d.c
  src/subgraph/square.c
  src/subgraph/square-root.c
  src/subgraph/squared-difference.c
  src/subgraph/subtract.c
  src/subgraph/unpooling-2d.c)

SET(XNNPACK_LOGGING_SRCS
  src/operator-strings.c
  src/subgraph-strings.c)

SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS} ${XNNPACK_SUBGRAPH_SRCS} ${XNNPACK_LOGGING_SRCS})
LIST(APPEND XNNPACK_COLD_SRCS
  src/init.c
  src/memory.c
  src/memory-planner.c
  src/operator-delete.c
  src/runtime.c
  src/subgraph.c
  src/tensor.c)

SET(XNNPACK_HOT_SRCS
  src/indirection.c
  src/packing.c
  src/operator-run.c)

SET(XNNPACK_TABLE_SRCS
  src/tables/exp2-k-over-64.c
  src/tables/exp2-k-over-2048.c)

SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
  src/f32-argmaxpool/4x-scalar-c1.c
  src/f32-argmaxpool/9p8x-scalar-c1.c
  src/f32-argmaxpool/9x-scalar-c1.c
  src/f32-avgpool/9p8x-minmax-scalar-c1.c
  src/f32-avgpool/9x-minmax-scalar-c1.c
  src/f32-clamp/gen/scalar-x1.c
  src/f32-clamp/gen/scalar-x2.c
  src/f32-clamp/gen/scalar-x4.c
  src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
  src/f32-conv-hwc2chw/3x3s2p1c3x4-scalar-1x1.c
  src/f32-dwconv-chw/3x3p1-scalar.c
  src/f32-dwconv-chw/3x3s2p1-scalar.c
  src/f32-dwconv-chw/5x5p2-scalar.c
  src/f32-dwconv-chw/5x5s2p2-scalar.c
  src/f32-dwconv/gen/up1x4-scalar.c
  src/f32-dwconv/gen/up1x4-scalar-acc2.c
  src/f32-dwconv/gen/up1x9-scalar.c
  src/f32-dwconv/gen/up1x9-scalar-acc2.c
  src/f32-dwconv/gen/up1x25-scalar.c
  src/f32-dwconv/gen/up1x25-scalar-acc2.c
  src/f32-dwconv/gen/up2x4-scalar.c
  src/f32-dwconv/gen/up2x4-scalar-acc2.c
  src/f32-dwconv/gen/up2x9-scalar.c
  src/f32-dwconv/gen/up2x9-scalar-acc2.c
  src/f32-dwconv/gen/up2x25-scalar.c
  src/f32-dwconv/gen/up2x25-scalar-acc2.c
  src/f32-dwconv/gen/up1x4-minmax-scalar.c
  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up1x9-minmax-scalar.c
  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up1x25-minmax-scalar.c
  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x4-minmax-scalar.c
  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x9-minmax-scalar.c
  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
  src/f32-dwconv/gen/up2x25-minmax-scalar.c
  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
  src/f32-gavgpool-cw/scalar-x1.c
  src/f32-gavgpool/7p7x-minmax-scalar-c1.c
  src/f32-gavgpool/7x-minmax-scalar-c1.c
  src/f32-gemm/gen/1x4-scalar.c
  src/f32-gemm/gen/2x4-scalar.c
  src/f32-gemm/gen/4x2-scalar.c
  src/f32-gemm/gen/4x4-scalar.c
  src/f32-gemm/gen/1x4-relu-scalar.c

=== debian/changelog ===
xnnpack (0.0~git20200827.37297a6-1) unstable; urgency=medium

  * New upstream version 0.0~git20200827.37297a6
  * Remove 533.patch (merged upstream) and refresh the remaining ones.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Sep 2020 10:37:10 +0800

xnnpack (0.0~git20200425.54f5917-4) unstable; urgency=medium

  * Strip and embedded clog and remove the corresponding patch.
  * Bump debhelper compat level to 13.
  * Remove README.Source, as the embedded clog has been removed.

 -- Mo Zhou <lumin@debian.org>  Fri, 01 May 2020 14:11:14 +0800

xnnpack (0.0~git20200425.54f5917-3) unstable; urgency=medium

  * Make the symbols control file amd64-only.
  * Override dh_dwz and allow it to fail on arm64.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 11:42:31 +0800

## xnnpack 0.0~git20201031.beca652

=== CMakeLists.txt ===
--- 
+++ 
@@ -172,6 +172,7 @@
   src/operators/leaky-relu-nc.c
   src/operators/max-pooling-nhwc.c
   src/operators/prelu-nc.c
+  src/operators/resize-bilinear-nchw.c
   src/operators/resize-bilinear-nhwc.c
   src/operators/sigmoid-nc.c
   src/operators/softmax-nc.c
@@ -190,8 +191,8 @@
   src/subgraph/deconvolution-2d.c
   src/subgraph/depthwise-convolution-2d.c
   src/subgraph/divide.c
+  src/subgraph/floor.c
   src/subgraph/fully-connected.c
-  src/subgraph/floor.c
   src/subgraph/global-average-pooling-2d.c
   src/subgraph/hardswish.c
   src/subgraph/leaky-relu.c
@@ -203,12 +204,12 @@
   src/subgraph/prelu.c
   src/subgraph/sigmoid.c
   src/subgraph/softmax.c
+  src/subgraph/square-root.c
+  src/subgraph/square.c
+  src/subgraph/squared-difference.c
   src/subgraph/static-constant-pad.c
   src/subgraph/static-reshape.c
   src/subgraph/static-resize-bilinear-2d.c
-  src/subgraph/square.c
-  src/subgraph/square-root.c
-  src/subgraph/squared-difference.c
   src/subgraph/subtract.c
   src/subgraph/unpooling-2d.c)
 
@@ -219,8 +220,8 @@
 SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS} ${XNNPACK_SUBGRAPH_SRCS} ${XNNPACK_LOGGING_SRCS})
 LIST(APPEND XNNPACK_COLD_SRCS
   src/init.c
+  src/memory-planner.c
   src/memory.c
-  src/memory-planner.c
   src/operator-delete.c
   src/runtime.c
   src/subgraph.c
@@ -228,12 +229,14 @@
 
 SET(XNNPACK_HOT_SRCS
   src/indirection.c
-  src/packing.c
-  src/operator-run.c)
+  src/operator-run.c
+  src/packing.c)
 
 SET(XNNPACK_TABLE_SRCS
   src/tables/exp2-k-over-64.c
-  src/tables/exp2-k-over-2048.c)
+  src/tables/exp2-k-over-2048.c
+  src/tables/exp2minus-k-over-64.c
+  src/tables/exp2minus-k-over-2048.c)
 
 SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
   src/f32-argmaxpool/4x-scalar-c1.c
@@ -244,42 +247,36 @@
   src/f32-clamp/gen/scalar-x1.c
   src/f32-clamp/gen/scalar-x2.c
   src/f32-clamp/gen/scalar-x4.c
+  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
   src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
   src/f32-conv-hwc2chw/3x3s2p1c3x4-scalar-1x1.c
-  src/f32-dwconv-chw/3x3p1-scalar.c
-  src/f32-dwconv-chw/3x3s2p1-scalar.c
-  src/f32-dwconv-chw/5x5p2-scalar.c
-  src/f32-dwconv-chw/5x5s2p2-scalar.c
+  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x4-minmax-scalar.c
+  src/f32-dwconv/gen/up1x4-scalar-acc2.c
   src/f32-dwconv/gen/up1x4-scalar.c
-  src/f32-dwconv/gen/up1x4-scalar-acc2.c
+  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x9-minmax-scalar.c
+  src/f32-dwconv/gen/up1x9-scalar-acc2.c
   src/f32-dwconv/gen/up1x9-scalar.c
-  src/f32-dwconv/gen/up1x9-scalar-acc2.c
+  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up1x25-minmax-scalar.c
+  src/f32-dwconv/gen/up1x25-scalar-acc2.c
   src/f32-dwconv/gen/up1x25-scalar.c
-  src/f32-dwconv/gen/up1x25-scalar-acc2.c
+  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x4-minmax-scalar.c
+  src/f32-dwconv/gen/up2x4-scalar-acc2.c
   src/f32-dwconv/gen/up2x4-scalar.c
-  src/f32-dwconv/gen/up2x4-scalar-acc2.c
+  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x9-minmax-scalar.c
+  src/f32-dwconv/gen/up2x9-scalar-acc2.c
   src/f32-dwconv/gen/up2x9-scalar.c
-  src/f32-dwconv/gen/up2x9-scalar-acc2.c
+  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
+  src/f32-dwconv/gen/up2x25-minmax-scalar.c
+  src/f32-dwconv/gen/up2x25-scalar-acc2.c
   src/f32-dwconv/gen/up2x25-scalar.c
-  src/f32-dwconv/gen/up2x25-scalar-acc2.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar.c
-  src/f32-dwconv/gen/up1x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar.c
-  src/f32-dwconv/gen/up1x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar.c
-  src/f32-dwconv/gen/up1x25-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar.c
-  src/f32-dwconv/gen/up2x4-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar.c
-  src/f32-dwconv/gen/up2x9-minmax-scalar-acc2.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar.c
-  src/f32-dwconv/gen/up2x25-minmax-scalar-acc2.c
-  src/f32-gavgpool-cw/scalar-x1.c
-  src/f32-gavgpool/7p7x-minmax-scalar-c1.c
-  src/f32-gavgpool/7x-minmax-scalar-c1.c
-  src/f32-gemm/gen/1x4-scalar.c
-  src/f32-gemm/gen/2x4-scalar.c
-  src/f32-gemm/gen/4x2-scalar.c
-  src/f32-gemm/gen/4x4-scalar.c
-  src/f32-gemm/gen/1x4-relu-scalar.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc2.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc3.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1-acc4.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-1x1.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-2x1-acc2.c
+  src/f32-dwconv2d-chw/gen/3x3p1-minmax-scalar-2x1.c

=== debian/changelog ===
xnnpack (0.0~git20201031.beca652-1) unstable; urgency=medium

  * New upstream snapshot 0.0~git20201031.beca652
  * Change maintainer into Debian Deep Learning Team <debian-ai@l.d.o>.
  * Refresh symbols list for amd64 architecture.

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 16:02:16 +0800

## xnnpack 0.0~git20201031.beca652+really.git20200323.1b35463

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# Copyright 2019 Google LLC
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)

INCLUDE(GNUInstallDirs)

# ---[ Project and semantic versioning.
PROJECT(XNNPACK C CXX ASM)

# ---[ Options.
SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
SET_PROPERTY(CACHE XNNPACK_LIBRARY_TYPE PROPERTY STRINGS default static shared)
OPTION(XNNPACK_ENABLE_ASSEMBLY "Build XNNPACK with assembly micro-kernels" ON)
OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
OPTION(XNNPACK_BUILD_BENCHMARKS "Build XNNPACK benchmarks" ON)

# ---[ CMake options
IF(XNNPACK_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

IF(XNNPACK_ENABLE_ASSEMBLY)
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=1)
ELSE()
  ADD_DEFINITIONS(-DXNN_ENABLE_ASSEMBLY=0)
ENDIF()

# ---[ Build flags
IF(NOT CMAKE_SYSTEM_PROCESSOR)
  IF(IOS)
    LIST(LENGTH IOS_ARCH IOS_ARCH_COUNT)
    IF(IOS_ARCH_COUNT GREATER 1)
      MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple iOS architectures (${IOS_ARCH}). "
        "Specify a single architecture in IOS_ARCH and re-configure. ")
    ENDIF()
    IF(NOT IOS_ARCH MATCHES "^(i386|x86_64|AMD64|armv7.*|arm64.*)$")
      MESSAGE(FATAL_ERROR "Unrecognized IOS_ARCH = ${IOS_ARCH}")
    ENDIF()
  ELSE()
    MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR is not defined")
  ENDIF()
ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|x86_64|AMD64|armv[5-8].*|aarch64)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_PROCESSOR = ${CMAKE_SYSTEM_PROCESSOR}")
ENDIF()

IF(NOT CMAKE_SYSTEM_NAME)
  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")
ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Darwin|Linux|Android|Windows)$")
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")
ENDIF()

# ---[ Download deps
IF(NOT DEFINED CLOG_SOURCE_DIR)
  MESSAGE(STATUS "Downloading clog to ${CMAKE_BINARY_DIR}/clog-source (define CLOG_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadCLog.cmake "${CMAKE_BINARY_DIR}/clog-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/clog-download")
  SET(CLOG_SOURCE_DIR "${CMAKE_BINARY_DIR}/clog-source" CACHE STRING "clog source directory")
ENDIF()

IF(NOT DEFINED CPUINFO_SOURCE_DIR)
  MESSAGE(STATUS "Downloading cpuinfo to ${CMAKE_BINARY_DIR}/cpuinfo-source (define CPUINFO_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadCpuinfo.cmake "${CMAKE_BINARY_DIR}/cpuinfo-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/cpuinfo-download")
  SET(CPUINFO_SOURCE_DIR "${CMAKE_BINARY_DIR}/cpuinfo-source" CACHE STRING "cpuinfo source directory")
ENDIF()

IF(NOT DEFINED FP16_SOURCE_DIR)
  MESSAGE(STATUS "Downloading FP16 to ${CMAKE_BINARY_DIR}/FP16-source (define FP16_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadFP16.cmake "${CMAKE_BINARY_DIR}/FP16-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FP16-download")
  SET(FP16_SOURCE_DIR "${CMAKE_BINARY_DIR}/FP16-source" CACHE STRING "FP16 source directory")
ENDIF()

IF(NOT DEFINED FXDIV_SOURCE_DIR)
  MESSAGE(STATUS "Downloading FXdiv to ${CMAKE_BINARY_DIR}/FXdiv-source (define FXDIV_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadFXdiv.cmake "${CMAKE_BINARY_DIR}/FXdiv-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  SET(FXDIV_SOURCE_DIR "${CMAKE_BINARY_DIR}/FXdiv-source" CACHE STRING "FXdiv source directory")
ENDIF()

IF(NOT DEFINED PSIMD_SOURCE_DIR)
  MESSAGE(STATUS "Downloading PSimd to ${CMAKE_BINARY_DIR}/psimd-source (define PSIMD_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadPSimd.cmake "${CMAKE_BINARY_DIR}/psimd-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/psimd-download")
  SET(PSIMD_SOURCE_DIR "${CMAKE_BINARY_DIR}/psimd-source" CACHE STRING "PSimd source directory")
ENDIF()

IF(NOT DEFINED PTHREADPOOL_SOURCE_DIR)
  MESSAGE(STATUS "Downloading pthreadpool to ${CMAKE_BINARY_DIR}/pthreadpool-source (define PTHREADPOOL_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadPThreadPool.cmake "${CMAKE_BINARY_DIR}/pthreadpool-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pthreadpool-download")
  SET(PTHREADPOOL_SOURCE_DIR "${CMAKE_BINARY_DIR}/pthreadpool-source" CACHE STRING "pthreadpool source directory")
ENDIF()

IF(XNNPACK_BUILD_TESTS AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Test to ${CMAKE_BINARY_DIR}/googletest-source (define GOOGLETEST_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  SET(GOOGLETEST_SOURCE_DIR "${CMAKE_BINARY_DIR}/googletest-source" CACHE STRING "Google Test source directory")
ENDIF()

IF(XNNPACK_BUILD_BENCHMARKS AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Benchmark to ${CMAKE_BINARY_DIR}/googlebenchmark-source (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CMAKE_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  SET(GOOGLEBENCHMARK_SOURCE_DIR "${CMAKE_BINARY_DIR}/googlebenchmark-source" CACHE STRING "Google Benchmark source directory")
ENDIF()

# ---[ XNNPACK library
SET(XNNPACK_OPERATOR_SRCS
  src/add-nc.c
  src/argmax-pooling-nhwc.c
  src/average-pooling-nhwc.c
  src/binary-elementwise-nd.c
  src/channel-pad-nc.c
  src/channel-shuffle-nc.c
  src/clamp-nc.c
  src/convolution-nchw.c
  src/convolution-nhwc.c
  src/deconvolution-nhwc.c
  src/fully-connected-nc.c
  src/global-average-pooling-ncw.c
  src/global-average-pooling-nwc.c
  src/hardswish-nc.c
  src/leaky-relu-nc.c
  src/max-pooling-nhwc.c
  src/prelu-nc.c
  src/resize-bilinear-nhwc.c
  src/sigmoid-nc.c
  src/softmax-nc.c
  src/unpooling-nhwc.c)

SET(XNNPACK_COLD_SRCS ${XNNPACK_OPERATOR_SRCS})
LIST(APPEND XNNPACK_COLD_SRCS
  src/init.c
  src/memory.c
  src/operator-delete.c
  src/runtime.c
  src/subgraph.c
  src/tensor.c)

SET(XNNPACK_HOT_SRCS
  src/indirection.c
  src/operator-run.c)

SET(XNNPACK_TABLE_SRCS
  src/tables/exp2-k-over-64.c
  src/tables/exp2-k-over-2048.c)

SET(XNNPACK_SCALAR_MICROKERNEL_SRCS
  src/f32-argmaxpool/4x-scalar-c1.c
  src/f32-argmaxpool/9p8x-scalar-c1.c
  src/f32-argmaxpool/9x-scalar-c1.c
  src/f32-avgpool/9p8x-scalar-c1.c
  src/f32-avgpool/9x-scalar-c1.c
  src/f32-clamp/gen/scalar-x1.c
  src/f32-clamp/gen/scalar-x2.c
  src/f32-clamp/gen/scalar-x4.c
  src/f32-conv-hwc/3x3s2p1c3x4-scalar-1x1.c
  src/f32-conv-hwc/3x3s2p0p1c3x4-scalar-1x1.c
  src/f32-conv-hwc2spchw/3x3s2p1c3x4-scalar-1x1.c
  src/f32-dwconv-spchw/3x3p1-scalar.c
  src/f32-dwconv-spchw/3x3s2p1-scalar.c
  src/f32-dwconv-spchw/5x5p2-scalar.c
  src/f32-dwconv-spchw/5x5s2p2-scalar.c
  src/f32-dwconv/gen/up1x25-scalar-acc2.c
  src/f32-dwconv/gen/up1x25-scalar.c
  src/f32-dwconv/gen/up1x4-scalar-acc2.c
  src/f32-dwconv/gen/up1x4-scalar.c
  src/f32-dwconv/gen/up1x9-scalar-acc2.c
  src/f32-dwconv/gen/up1x9-scalar.c
  src/f32-dwconv/gen/up2x25-scalar-acc2.c
  src/f32-dwconv/gen/up2x25-scalar.c
  src/f32-dwconv/gen/up2x4-scalar-acc2.c
  src/f32-dwconv/gen/up2x4-scalar.c
  src/f32-dwconv/gen/up2x9-scalar-acc2.c
  src/f32-dwconv/gen/up2x9-scalar.c
  src/f32-gavgpool-spchw/scalar-x1.c
  src/f32-gavgpool/7p7x-scalar-c1.c
  src/f32-gavgpool/7x-scalar-c1.c
  src/f32-gemm/gen/1x4-scalar.c
  src/f32-gemm/gen/2x4-scalar.c
  src/f32-gemm/gen/4x2-scalar.c
  src/f32-gemm/gen/4x4-scalar.c
  src/f32-gemm/gen-inc/1x4-scalar.c
  src/f32-gemm/gen-inc/2x4-scalar.c
  src/f32-gemm/gen-inc/4x4-scalar.c
  src/f32-hswish/gen/scalar-x1.c
  src/f32-hswish/gen/scalar-x2.c
  src/f32-hswish/gen/scalar-x4.c
  src/f32-ibilinear/gen/scalar-c1.c
  src/f32-ibilinear/gen/scalar-c2.c
  src/f32-ibilinear/gen/scalar-c4.c
  src/f32-igemm/gen/1x4-scalar.c
  src/f32-igemm/gen/2x4-scalar.c
  src/f32-igemm/gen/4x2-scalar.c
  src/f32-igemm/gen/4x4-scalar.c
  src/f32-maxpool/9p8x-scalar-c1.c
  src/f32-pavgpool/9p8x-scalar-c1.c
  src/f32-pavgpool/9x-scalar-c1.c
  src/f32-ppmm/gen/2x4-scalar.c
  src/f32-ppmm/gen/3x3-scalar.c
  src/f32-ppmm/gen/4x2-scalar.c
  src/f32-ppmm/gen/4x4-scalar.c
  src/f32-prelu/gen/scalar-2x1.c
  src/f32-prelu/gen/scalar-2x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x1.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x2-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-lut64-p2-x4-acc4.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x1.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x2-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4-acc2.c
  src/f32-raddstoreexpminusmax/gen/scalar-p5-x4-acc4.c
  src/f32-rmax/scalar.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x1.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x2.c
  src/f32-sigmoid/gen/scalar-lut2048-p1-div-x4.c
  src/f32-sigmoid/gen/scalar-lut64-p2-div-x1.c
  src/f32-sigmoid/gen/scalar-lut64-p2-div-x2.c
  src/f32-sigmoid/gen/scalar-lut64-p2-div-x4.c
  src/f32-sigmoid/gen/scalar-p5-div-x1.c
  src/f32-sigmoid/gen/scalar-p5-div-x2.c
  src/f32-sigmoid/gen/scalar-p5-div-x4.c
  src/f32-spmm/gen/1x1-scalar-pipelined.c
  src/f32-spmm/gen/1x1-scalar.c
  src/f32-spmm/gen/2x1-scalar-pipelined.c
  src/f32-spmm/gen/2x1-scalar.c
  src/f32-spmm/gen/4x1-scalar-pipelined.c
  src/f32-spmm/gen/4x1-scalar.c
  src/f32-spmm/gen/8x1-scalar-pipelined.c
  src/f32-spmm/gen/8x1-scalar.c
  src/f32-spmm/gen/8x2-scalar.c
  src/f32-spmm/gen/8x4-scalar.c
  src/f32-vbinary/gen/vadd-scalar-x1.c
  src/f32-vbinary/gen/vadd-scalar-x2.c
  src/f32-vbinary/gen/vadd-scalar-x4.c
  src/f32-vbinary/gen/vaddc-scalar-x1.c
  src/f32-vbinary/gen/vaddc-scalar-x2.c
  src/f32-vbinary/gen/vaddc-scalar-x4.c
  src/f32-vbinary/gen/vdiv-scalar-x1.c
  src/f32-vbinary/gen/vdiv-scalar-x2.c
  src/f32-vbinary/gen/vdiv-scalar-x4.c
  src/f32-vbinary/gen/vdivc-scalar-x1.c
  src/f32-vbinary/gen/vdivc-scalar-x2.c
  src/f32-vbinary/gen/vdivc-scalar-x4.c
  src/f32-vbinary/gen/vmax-scalar-x1.c
  src/f32-vbinary/gen/vmax-scalar-x2.c

=== debian/changelog ===
xnnpack (0.0~git20201031.beca652+really.git20200323.1b35463-2) unstable; urgency=medium

  * Don't install unwanted header files.
  * Revert "Remove 533.patch (merged upstream) and refresh the remaining ones."
    We need this patch again due to the rollback.

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Dec 2020 13:50:30 +0800

xnnpack (0.0~git20201031.beca652+really.git20200323.1b35463-1) unstable; urgency=medium

  * Rollback to upstream snapshot 0.0~git20200323.1b35463
  * Please pin to this snapshot for PyTorch 1.7.0
  * Rebase existing patches.
  * Stop tracking symbols, and update not-installed list.

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Dec 2020 12:33:46 +0800
